/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 27.04.2015
  * @author Michael Ziemke, Koeln fr LLG
  */

public class Morsebaum {
  
  // Anfang Attribute
  private BinaryTree meinBaum;
  private boolean nurAlphabet = true;  // nur 26 Knoten mit Buchstaben, keine Umlaute
  // Ende Attribute
  
  // Anfang Methoden
  public Morsebaum (boolean pNurAlphabet)
  {
    this.nurAlphabet = pNurAlphabet;
    initBaum();
  } 
  
  /**
   * erzeugt den Morsebaum
   */
  private void initBaum ()
  {
    // linke Teilbaumstruktur:
    BinaryTree b1,b2,b3,b4; 
    b1 = new BinaryTree ("S", new BinaryTree ("H"), new BinaryTree ("V"));
    b4 = null; if (!this.nurAlphabet) b4 = new BinaryTree ("");
    // Folgendes nur zur Ansicht, also bitte NDERN:
    this.meinBaum = new BinaryTree ("U", new BinaryTree ("F"), b4);
    // HIER ERGNZEN
    // rechte Teilbaumstruktur:
    // HIER ERGNZEN
    // komplette Struktur:
    // HIER ERGNZEN
  }
  /**
  * liefert den Klartext zum bernommenen Morse-Code
  * @param String pCode : der Morsecode (mit . und -, getrennt durch Leerzeichen)
  * @return String : der Klartext
  */
  public String morseDecodieren(String pCode)
  {
    String ret = "Das Decodieren fehlt noch!";
    // HIER ERGNZEN
    return ret; 
  }  
  
  /**
  * liefert die korrekte String-Reprsentanz des Morsebaumes
  * mit . nach jedem Knoteninhalt und # nach Blattinhalt
  * gem des Attributwertes nurAlphabet (true = ohne Umlaute)
  * @return String : die zu diesem Morsebaum gehrende String-Reprsentanz
  */
  public String getPruefString()
  { String ret = "_.E.I.S.H.#V.#U.F.#.#A.R.L.#.#W.P.#J.#T.N.D.B.#X.#K.C.#Y.#M.G.Z.#Q.#O..#CH.#";
    if (this.nurAlphabet) {
      ret = "_.E.I.S.H.#V.#U.F.#A.R.L.#W.P.#J.#T.N.D.B.#X.#K.C.#Y.#M.G.Z.#Q.#O.#";
    } // end of if
    return ret;
  }
  
  /**
  * liefert eine durch PreOrder-Traversierung erzeugte String-Reprsentanz
  * des erzeugten Morsebaumes
  * @return String : die zu diesem Morsebaum gehrende String-Reprsentanz
  */
  public String getBaumString()
  {
    return this.preorder_rek(meinBaum, "");
  }  
  /**
  * prft durch preorder-Traversierung die Korrektheit des Morsebaums
  * @return boolean : true, falls String-Reprsentanz des Baumes dem PrfString entspricht
  */
  public boolean pruefeBaum ()
  {
    String pruefString = this.getPruefString();
    return pruefString.equals(this.getBaumString());
  }   
  
  /**
  * traversiert eine Baumstruktur ab dem bernommenen Knoten rekursiv mit preorder
  * (also Wurzelinhalt, dann linker, dann rechter Teilbaum)
  * und liefert einen String mit allen Knoteninhalten (gefolgt von einem Punkt)
  * und mit Zeichen #, falls der Knoten ein Blatt ist (nur leere Teilbume hat)
  * Bsp.: _.E.I.S.H.#V.#U.F.#A.R.L.#W.P.#J.#T.N.D.B.#X.#K.C.#Y.#M.G.Z.#Q.#O.#
  * @return String : String-Reprsentanz der verarbeiteten Baumstruktur
  */
  private String preorder_rek(BinaryTree pTree, String pText)
  {
    BinaryTree lTree;
    boolean istBlatt = true;
    if (!pTree.isEmpty()) {
      pText += pTree.getObject() + ".";
    } // end of if
    lTree = pTree.getLeftTree();
    if (!lTree.isEmpty()) {
      istBlatt = false;
      pText = this.preorder_rek (lTree, pText);
    } // end of if
    lTree = pTree.getRightTree();
    if (!lTree.isEmpty()) {
      istBlatt = false;
      pText = this.preorder_rek (lTree, pText);
    } // end of if
    if (istBlatt) {
      pText += "#";
    } // end of if
    return pText;
  }    
  
  // Ende Methoden
} // end of Morsebaum
